/*
    $Id: base64.c 292 2010-02-14 07:37:34Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include <stdlib.h>
#include "base64.h"

int base64DecHelper(char byte);

//after function returns free t_b64
int base64Enc(unsigned char *data, unsigned char **t_b64, int sz)
{
    int b64Size = 0;
    int dat_cntr = 0;
    int b64_cntr = 0;
    unsigned char *dataPtr = 0;
    int suffixCnt = 0;

    b64Size = ((sz*8)/6);
    b64Size += (((sz*8)%6) == 4) ? 3 : 0;
    b64Size += (((sz*8)%6) == 2) ? 2 : 0;

    suffixCnt = 0;

    if ( ((sz*8)%6) == 4  )
        suffixCnt = 1;

    if ( ((sz*8)%6) == 2 )
        suffixCnt = 2;

    *t_b64 = calloc(sizeof(char),b64Size+1);
    dataPtr = data;

    while ( dat_cntr < sz-1 )
    {
        (*t_b64)[b64_cntr+0] = B64[(*dataPtr)>>2];
        (*t_b64)[b64_cntr+1] = B64[(((*dataPtr)& 0x03)<<4)|(((*(dataPtr+1))&0xf0)>>4)];
        (*t_b64)[b64_cntr+2] = B64[(((*(dataPtr+1))&0x0f)<<2)|(((*(dataPtr+2))&0xc0)>>6)];
        (*t_b64)[b64_cntr+3] = B64[(*(dataPtr+2))&0x3f];

        dataPtr+=3;
        b64_cntr+=4;
        dat_cntr+=3;
    }
	
    while ( suffixCnt != 0)
    {
        (*t_b64)[b64Size-suffixCnt] = '=';
        suffixCnt--;
    }

    return b64Size;
}

//after function returns free data
int base64Dec(unsigned char **data, unsigned char *t_b64, int sz)
{
    int decSz = 0;
    int dat_cntr = 0;
    int b64_cntr = 0;
    int cntr = 0;
    unsigned char *b64_dataPtr = 0;
    unsigned char *dataPtr = 0;
    int suffixCnt = 0;
    int a = 0, b = 0, c = 0, d = 0;
    int suffixAdjuster = 0;

	suffixCnt = 0;
    cntr = sz;
    while ( cntr > sz-3)
    {
        if ( t_b64[cntr-1] == '=')
            suffixCnt++;
        cntr--;
    }
	
    suffixAdjuster = 0;
    suffixAdjuster = (suffixCnt == 2) ? 3 : 0;
    suffixAdjuster = (suffixCnt == 4) ? 2 : 0;
	
    decSz = (((sz - suffixAdjuster)*6)/8);
    *data = calloc(sizeof(unsigned char),decSz+1);
    dataPtr = *data;
    b64_dataPtr =  t_b64;

    while ( b64_cntr < sz )
    {
        a = base64DecHelper(*b64_dataPtr);
        b = base64DecHelper(*(b64_dataPtr+1));
        c = base64DecHelper(*(b64_dataPtr+2));
        d = base64DecHelper(*(b64_dataPtr+3));

        *dataPtr = (((a)<<2)&0xfc) | (((b)>>4)&0x03);
        *(dataPtr+1) = (((b)<<4)&0xf0) | (((c)>>2)&0x0f);
        *(dataPtr+2) = (((c)<<6)&0xc0) | (((d))&0x3f);
        dataPtr+=3;
        dat_cntr+=3;
        b64_dataPtr+=4;
        b64_cntr+=4;
    }

    return decSz+1;
}

int base64DecHelper(char byte)
{
    int cntr = 0;
    while (cntr < 64)
    {
        if (B64[cntr] == byte )
            return cntr;
        cntr++;
    }
    return 0;
}
