/*
    $Id: filepanel.h 301 2010-02-17 21:00:48Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef FILEPANEL_H
#define FILEPANEL_H

#include <QtGui/QWidget>
#include <QtGui/QHBoxLayout>
#include <QtGui/QVBoxLayout>
#include <QtGui/QLineEdit>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QTextEdit>
#include <QtGui/QFileDialog>

class filepanel : public QWidget
{
    Q_OBJECT
public:
    filepanel(QWidget* parent = 0);
    virtual ~filepanel();

private:
    QVBoxLayout* v1;
    QHBoxLayout* h1;
    QHBoxLayout* h2;
    QHBoxLayout* h3;
    QHBoxLayout* h4;
    QLineEdit* filepathEdit;
    QLineEdit* password1;
    QLineEdit* password2;
    QTextEdit* msgBox;
    QLabel* fileLabel;
    QLabel* passwordLabel;
    QPushButton* browseButton;
    QPushButton* encryptButton;
    QPushButton* decryptButton;

private slots:
    void getFileFromBrowser();
    void validateForm(const QString&);
    void encryptFile();
    void decryptFile();
};

#endif // FILEPANEL_H
