/*
    $Id: glob.h 286 2010-02-12 18:53:59Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifdef __cplusplus
extern "C" {
#endif
#ifndef GLOB_H
#define GLOB_H

    static const int END_TST = 0x01;
#define L_ENDIAN() ((*(char*)&END_TST)==1)
#define LRT(x, y) (((x)<<(y))^((x)>>(32-y)))

#define REVBYTE32(w){							\
    unsigned int tmp = (w);						\
    tmp = (tmp >> 16) | (tmp << 16);					\
    (w) = ((tmp & 0xff00ff00UL) >> 8) | ((tmp & 0x00ff00ffUL) << 8);	\
  }

#define REVBYTE64(w){							\
    unsigned long long int tmp = (w);					\
    unsigned long long int r;						\
    unsigned long long int l;						\
    tmp = (tmp << 32) | (tmp >> 32);					\
    l = ((tmp & 0xff000000ff000000ULL) >> 24) | ((tmp & 0x000000ff000000ffULL) << 24); \
    r = ((tmp & 0x00ff000000ff0000ULL) >> 8) | ((tmp & 0x0000ff000000ff00ULL) << 8 ); \
    (w) = (l) | (r);							\
  }


    /* Error constants */
#define FILEIO_ERROR 0x3000
#define FILEFORMAT_ERROR 0x3001
#define FILESZ_OUTBOUND 0x3002

#define NET_ERR 0x9003
#define BAD_NET 0x9004

#define CON_CLOSE 0x8005
#define CON_TIMEOUT 0x8007

#define BAD_PASS 0x4005
#define SHA_ERR 0x4007

#define ENC_EXT 0x5008

    /* end ---------- Error constants */


#define PARS_DIR_PATH ".ko-parsdir"
#define PARS_ERR_CACHE ".ko-err"

#endif /* GLOB_H */
#ifdef __cplusplus
}
#endif

