/*
    $Id: hashpanel.h 301 2010-02-17 21:00:48Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HASHPANEL_H
#define HASHPANEL_H

#include <QtGui/QWidget>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QTextEdit>
#include <QtGui/QLineEdit>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QFileDialog>

class hashpanel : public QWidget
{
    Q_OBJECT
public:
    hashpanel(QWidget* parent = 0);
    virtual ~hashpanel();
private:
    QLabel* directoryLabel;
    QLabel* fileLabel;
    QLineEdit* dirpathEdit;
    QLineEdit* filepathEdit;
    QTextEdit* messageBox;
    QPushButton* gethashButton1;
    QPushButton* gethashButton2;
    QPushButton* browseButton1;
    QPushButton* browseButton2;
    QVBoxLayout* v1;
    QHBoxLayout* h1;
    QHBoxLayout* h2;
    QHBoxLayout* h3;
    QHBoxLayout* h4;
private slots:
    void getDirectoryFromBrowser();
    void getFileFromBrowser();
    void validateForm(const QString&);
    void hashDirectory();
    void hashFile();
};

#endif // HASHPANEL_H
