/*
    $Id: kcore.h 299 2010-02-17 03:21:45Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KCORE_H
#define KCORE_H

#include "glob.h"
#include "util.h"
#include "base64.h"
#include "aes.h"
#include "sha.h"
#include "rand.h"

#include <string>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <math.h>

#include <QtGui/QWidget>
#include <QtGui/QTextEdit>


class kcore
{
public:
    kcore();
    static int encryptKFile(std::string file, std::string key);
    static int decryptKFile(std::string file, std::string key);
    static int hashKFile(std::string file, QTextEdit *msg);
    static int encryptKDir(std::string dir, std::string key, QTextEdit *msg);
    static int decryptKDir(std::string dir, std::string key, QTextEdit *msg);
    static int hashKDir(std::string dir, QTextEdit *msg);
    static int encryptKMsg(std::string key, QTextEdit *msg);
    static int decryptKMsg(std::string key, QTextEdit *msg);
    static std::string errorMessage(unsigned int ret);
    virtual ~kcore();
};

#endif // KCORE_H
