/*
    $Id: kgui.cpp 301 2010-02-17 21:00:48Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include "kgui.h"

#include <QtGui/QLabel>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QAction>
#include <QtGui/QVBoxLayout>

#include "kokla.xpm"
#include "shutdown.xpm"
#include "about.xpm"
#include "filepanel.h"
#include "directorypanel.h"
#include "messagepanel.h"
#include "hashpanel.h"
#include "aboutwindow.h"

kgui::kgui()
{
    tabWidget = new QTabWidget(this);
    aboutAction = new QAction(this);
    quitAction = new QAction(this);
    fileMenu = new QMenu();

    aboutWin = new aboutwindow(this);
    aboutWin->hide();

    tabWidget->addTab(new filepanel(this),tr("F&ile"));
    tabWidget->addTab(new directorypanel(this),tr("&Directory"));
    tabWidget->addTab(new messagepanel(this),tr("&Message"));
    tabWidget->addTab(new hashpanel(this),tr("SH&A1"));

    setCentralWidget(tabWidget);
    setWindowIcon(QIcon(QPixmap(kokla_xpm)));
    setWindowTitle(QString("Kokla"));

    aboutAction->setText("&About");
    aboutAction->setIcon(QIcon(QPixmap(about_xpm)));

    quitAction->setText( "&Quit" );
    quitAction->setIcon(QIcon(QPixmap(shutdown_xpm)));

    connect(quitAction, SIGNAL(triggered()), SLOT(close()));
    connect(aboutAction, SIGNAL(triggered()), SLOT(about()));

    fileMenu = menuBar()->addMenu( "&Help" );
    fileMenu->addAction( aboutAction );
    fileMenu->addAction( quitAction );

    setFixedSize(530, 400);
}

kgui::~kgui()
{
    delete(tabWidget);
    delete(aboutAction);
    delete(quitAction);
    delete(fileMenu);
}


void kgui::about()
{
    aboutWin->show();
}

#if OS == 0x03
#include "kgui.moc"
#endif