/*
    $Id: net.h 286 2010-02-12 18:53:59Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifdef __cplusplus
extern "C" {
#endif
#ifndef NET_H
#define NET_H

#if OS == 0x03  //Linux OS
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

#if OS == 0x02  //Windows
#include <windows.h>
#endif

    typedef struct
    {
        unsigned char host[25];
        unsigned int sock_proto;
#if OS == 0x03  //Linux OS
        struct sockaddr_in sa;
        int sock;
#endif
#if OS == 0x02  //Windows
        SOCKET sock;
        SOCKADDR_IN sa;
#endif

    } net_ctx;

    int netInit(net_ctx **ctx, unsigned char host[255], int port,
                int sock_fam, int sock_type, int sock_proto);
    void netDestroy(net_ctx **ctx);
    int lisNet(net_ctx **ctx);
    int connNet(net_ctx **ctx);
    int sndData(net_ctx **ctx, unsigned char data[20]);
    int getData(net_ctx **ctx, unsigned char data[20]);


#endif /* NET_H */
#ifdef __cplusplus
}
#endif

