/*
    $Id: sha.h 286 2010-02-12 18:53:59Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifdef __cplusplus
extern "C" {
#endif

#ifndef SHA_H
#define SHA_H

    static unsigned int h0 = 0x67452301;
    static unsigned int h1 = 0xEFCDAB89;
    static unsigned int h2 = 0x98BADCFE;
    static unsigned int h3 = 0x10325476;
    static unsigned int h4 = 0xC3D2E1F0;

    typedef struct
    {
        unsigned int h0;
        unsigned int h1;
        unsigned int h2;
        unsigned int h3;
        unsigned int h4;
    } DIGEST;

    typedef struct
    {
        unsigned long long int size;
        unsigned long long int r_len;
        DIGEST hash;
    } shactx;

    int initSHA(shactx **ctx, unsigned long long int size);
    void destroySHA(shactx *ctx);
    void nxtHash(shactx *ctx, char data[64]);

#endif /* SHA_H */
#ifdef __cplusplus
}
#endif
