/*
    $Id: util.h 286 2010-02-12 18:53:59Z irfangul82 $
    Simple file and directory encryption
    Copyright (C) 2010  Irfan Gulamali

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/*
 * Utility functions are placed
 * here for other functions to
 * make use of.
 *
 * code placed here should be used to
 * wrap ugly code ie. IO and network
 */
#ifdef __cplusplus
extern "C" {
#endif
#ifndef UTIL_H
#define UTIL_H

#include <limits.h>

    int gtHash(unsigned char *fname, unsigned char *hash);
    int gtHashDir(unsigned char *fname);
    int encryptFile(unsigned char *fname, unsigned char* encKey);
    int decryptFile(unsigned char *fname, unsigned char* encKey);
    int encryptDir(unsigned char *fname, unsigned char* encKey);
    int decryptDir(unsigned char *fname, unsigned char* encKey);
    void parseFileName(unsigned char *fname, unsigned char **pars_fl);
    int parseDirTree(unsigned char *path);
    int parseDirDBClean();
    int encMsg(unsigned char *fname, unsigned char* encKey);
    int decMsg(unsigned char *fname, unsigned char* encKey);

#endif /* UTIL_H */
#ifdef __cplusplus
}
#endif

